// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'dart:async';

import 'package:wyatt_architecture/wyatt_architecture.dart';
import 'package:wyatt_cloud_messaging_bloc_base/src/domain/entities/remote_notifications.dart';

abstract class CloudMessagingRepository extends BaseRepository {
  FutureOrResult<void> init();

  FutureOrResult<Stream<RemoteNotification>> onNotification();

  FutureOrResult<Stream<RemoteNotification>> onNotificationBackground();

  FutureOrResult<Stream<RemoteNotification>> onNotificationForeground();

  FutureOrResult<void> requestPermissions();

  FutureOrResult<String?> getToken();

  FutureOrResult<void> subscribeToTopic(String topic);

  FutureOrResult<void> unsubscribeFromTopic(String topic);
}
