// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:crud_bloc_example/models.dart';
import 'package:wyatt_crud_bloc/wyatt_crud_bloc.dart';

/// A [CrudCubit] for [User].
class UserCubit extends CrudCubit<User> {
  final CrudRepository<User> _crudRepository;

  UserCubit(this._crudRepository);

  @override
  CreateOperation<User, dynamic>? get createOperation =>
      Create(_crudRepository);

  @override
  DeleteOperation<User, dynamic>? get deleteOperation =>
      Delete(_crudRepository);

  @override
  ReadOperation<User, dynamic, dynamic>? get readOperation =>
      GetAll(_crudRepository);

  @override
  UpdateOperation<User, dynamic>? get updateOperation =>
      Update(_crudRepository);
}
